import excel "C:\IPT Data\Dataset.xlsx", sheet("Sheet1") firstrow
//Setting time variable
gen time=(CurrentTB_date- enrollment_date)/360
replace time=(last_visit_date-enrollment_date)/360 if TB=="No"
//Setting outcome variable
gen Outcome=0 if TB=="No"
replace Outcome=1 if TB=="Yes"
//Declaring survival data with ID variable
stset time, id(ID) failure(Outcome==1)
//Demarkating which records to split and at what time
gen ARTtime=(ARTstartdate-enrollment_date)/360 if ARTinitiation=="Yes"
//Splitting the records
stsplit ART, at(0) after(_t=ARTtime)
replace ART = ART + 1
//Since only records still uncensored at time of splitting are split, outcome for the first 
//part of the records after splitting must be set to zero 
replace Outcome=0 if ART==1 & Outcome==.
//Again first part of the records that were split must be set to zero, or in this case 
//must be labled as 'PreART'
replace ART=0 if ART==1 & ARTtime==.
//Saving dataset upto this point before droping all records but ART period records before splitting 
//it into various ART duration categories
save "C:\IPT Data\temp\ART.dta"
keep if ART==1
gen ART6time=.5
stsplit ART6, at(0) after(_t=ART6time)
replace ART6 = ART6 + 1
replace Outcome=0 if ART6==1 & Outcome==.
replace ART6=0 if ART6==1 & ART6time==.
save "C:\IPT Data\temp\ART6.dta"
//ART 24 months
keep if ART6==1
gen ART24time=2
stsplit ART24, at(0) after(_t=ART24time)
replace ART24 = ART24 + 1
replace Outcome=0 if ART24==1 & Outcome==.
replace ART24=0 if ART24==1 & ART24time==.
save "C:\IPT Data\temp\ART24.dta"
//ART 42 year
keep if ART24==1
gen ART42time=3.5
stsplit ART42, at(0) after(_t=ART42time)
replace ART42 = ART42 + 1
replace Outcome=0 if ART42==1 & Outcome==.
replace ART42=0 if ART42==1 & ART42time==.
save "C:\IPT Data\temp\ART42.dta"
//
use "C:\IPT Data\temp\ART.dta", clear
drop if ART==1
append using "C:\IPT Data\temp\ART6.dta", generate(append1)
drop if ART6==1
append using "C:\IPT Data\temp\ART24.dta", generate(append2)
drop if ART24==1
append using "C:\IPT Data\temp\ART42.dta", generate(append3)
//
gen ARTduration=0 if ART==0
replace ARTduration=1 if ART6==0
replace ARTduration=2 if ART24==0
replace ARTduration=3 if ART42==0
replace ARTduration=4 if ART42==1
stset time, id(ID) failure(Outcome==1) scale(1)
gen AGE=0 if age<15
replace AGE=1 if age>=15 & age<49
replace AGE=2 if age>=49
gen SEX=0 if sex=="Female"
replace SEX=1 if sex=="Male"
gen STAGE=0 if WHO_stage=="I or II"
replace STAGE=1 if WHO_stage=="III or IV"
gen CTX=0 if Cotrimoxazol=="No"
replace CTX=1 if Cotrimoxazol=="Yes"
gen CD4=0 if Baseline_CD4=="<100"
replace CD4=1 if Baseline_CD4=="100-199"
replace CD4=2 if Baseline_CD4=="200-349"
replace CD4=3 if Baseline_CD4==">349"
//Incidence, total
stptime
//Incidence by covariates
by AGE, sort : stptime
by SEX, sort : stptime
by STAGE, sort : stptime
by CD4, sort : stptime
by CTX, sort : stptime
by ARTduration, sort : stptime
//Univariable analysis
stcox i.AGE, strata(Site)
stcox SEX, strata(Site)
stcox STAGE, strata(Site)
stcox CTX, strata(Site)
stcox i.CD4, strata(Site)
stcox i.ARTduration, strata(Site)
//Multivariable analysis
stcox i.ARTduration SEX STAGE CTX i.CD4, strata(Site)
