import excel "C:\IPT Data\Dataset.xlsx", sheet("Sheet1") firstrow
//Setting time variable
gen time=(CurrentTB_date- enrollment_date)/360
replace time=(last_visit_date-enrollment_date)/360 if TB=="No"
//Setting outcome variable
gen Outcome=0 if TB=="No"
replace Outcome=1 if TB=="Yes"
//Declaring survival data with ID variable
stset time, id(ID) failure(Outcome==1)
//Demarcating which records to split and at what time
gen IPTtime=(INH_date-enrollment_date)/360 if INH=="Yes"
//Splitting the records
stsplit IPT, at(0) after(_t=IPTtime)
replace IPT = IPT + 1
//Since only records still uncensored at time of splitting are split, outcome for the first 
//part of the records after splitting must be set to zero 
replace Outcome=0 if IPT==1 & Outcome==.
//Again first part of the records that were split must be set to zero, or in this case 
//must be labled as 'NO INH'
replace IPT=0 if IPT==1 & IPTtime==.
//Labeling IPT completion category
gen IPT_completion=0 if INH_complition=="No IPT"
replace IPT_completion=1 if INH_complition=="IPT completion"
replace IPT_completion=2 if INH_complition=="IPT non-completion"
gen AGE=0 if age<15
replace AGE=1 if age>=15 & age<49
replace AGE=2 if age>=49
gen SEX=0 if sex=="Female"
replace SEX=1 if sex=="Male"
gen CTX=0 if Cotrimoxazol=="No"
replace CTX=1 if Cotrimoxazol=="Yes"
gen STAGE=0 if WHO_stage=="I or II"
replace STAGE=1 if WHO_stage=="III or IV"
gen CD4=0 if Baseline_CD4=="<100"
replace CD4=1 if Baseline_CD4=="100-199"
replace CD4=2 if Baseline_CD4=="200-349"
replace CD4=3 if Baseline_CD4==">349"
stset time, id(ID) failure(Outcome==1) scale(1)
//Incidence, total
stptime
//Incidence by covariates
by AGE, sort : stptime
by SEX, sort : stptime
by STAGE, sort : stptime
by CD4, sort : stptime
by CTX, sort : stptime
by IPT_completion, sort : stptime
//by IPT intake
by INH, sort : stptime
//incidence rate ratio by IPT intake
stir INH
//Univariable analysis
stcox i.AGE, strata(Site)
stcox SEX, strata(Site)
stcox STAGE, strata(Site)
stcox CTX, strata(Site)
stcox i.CD4, strata(Site)
stcox i.IPT_completion, strata(Site)
//Multivariable analysis
stcox i.IPT_completion SEX STAGE CTX i.CD4, strata(Site)

